//
// FILE: MultTimer2.h
//
// Copyright (c) 1997 by Aaron Michael Cohen and Mike Woodring
//
/////////////////////////////////////////////////////////////////////////

#include <afxwin.h>
#include <afxext.h>
#include <time.h>
#include "resource.h"

#include "Mcl4Mfc.h"

#define WM_SHUTDOWN_THREAD  (WM_USER + 1024)

class CMultTimerApp : public CWinApp {
public:
    virtual BOOL InitInstance(void);
};

class CMultTimerThread : public CMcl4MfcGUIThread {
public:
    virtual BOOL InitInstance(void);    
    virtual BOOL PreTranslateMessage( MSG *pMsg);

    afx_msg void OnShutdownThread( UINT wParam, LONG lParam);
};

class CMultTimerDlg : public CDialog {
public:
    CMultTimerDlg();
    virtual BOOL OnInitDialog();

protected:
    virtual void OnCancel();
    virtual void OnOK();
    virtual void PostNcDestroy();

    afx_msg void OnPaint();
    afx_msg void OnSysCommand( UINT nID, LPARAM lParam);

    DECLARE_MESSAGE_MAP()

private:
    clock_t m_ctStartTime;
    CRect m_crLastPaint;
    CEdit m_ceSeconds;
    BOOL m_bTimerRunning;
    int m_nTicks;
    static int s_LastDialogX;
    static int s_LastDialogY;
    static CMclQueue<CMcl4MfcGUIThread *> m_cqChildThreads;
};

