//
// FILE: DynamiteThread.h
//
// Copyright (c) 1997 by Aaron Michael Cohen and Mike Woodring
//
/////////////////////////////////////////////////////////////////////////

#ifndef __DynamiteThread_H__
#define __DynamiteThread_H__

#include "CGuardedThreadHandler.h"

// Define a dynamite threads - a thread that tends to blow up.
//
class CDynamiteThread : public CGuardedThreadHandler
{
    public:
        // The pure virtual GuardedThreadHandlerProc must be overridden
        // to supply the body of the thread procedure.
        //
        virtual unsigned GuardedThreadHandlerProc( void );

        // The ExceptionFilter and TerminationHandler functions are overridden
        // just to show how and when they're invoked when an exception occurs.
        //
        virtual int ExceptionFilter( DWORD dwExceptionCode, LPEXCEPTION_POINTERS pEP );
        virtual unsigned TerminationHandler( DWORD dwExceptionCode );
};

#endif // __DynamiteThread_H__
